local AddonName, a = ...
if a.BuildFail(50000) then return end
local s = SpellFlashAddon
local x = s.UpdatedVariables

x.Action = {}
s.UpdateCastTime = function(spellId)
	local name, _, _, castTime = GetSpellInfo(spellId)
	name = s.NormalizeName(name)
	if not x.Action[name] then
		x.Action[name] = {}
	end
	x.Action[name].cast_time = castTime / 1000
	x.Action[name].execute_time = math.max(s.GlobalCooldown(), castTime / 1000)
end

s.UpdateCharges = function(spellId)
	local name, _, _, castTime = GetSpellInfo(spellId)
	name = s.NormalizeName(name)
	if not x.Action[name] then
		x.Action[name] = {}
	end
	x.Action[name].cast_time = castTime / 1000
	x.Action[name].execute_time = math.max(s.GlobalCooldown(), castTime / 1000)

	local currentCharges, maxCharges, cooldownStart, cooldownDuration = GetSpellCharges(spellId)
	if currentCharges < maxCharges then
		x.Action[name].charges_nogcd = math.floor(currentCharges + (GetTime() - cooldownStart) / cooldownDuration)
		x.Action[name].charges = math.floor(math.min(maxCharges, currentCharges + (GetTime() + math.max(s.GlobalCooldown(), s.GetCasting(nil, "player")) - cooldownStart) / cooldownDuration))
	else
		x.Action[name].charges_nogcd = maxCharges
		x.Action[name].charges = maxCharges
	end
end

s.UpdateInFlight = function(spellId)
	local name, _, _, castTime = GetSpellInfo(spellId)
	name = s.NormalizeName(name)
	if not x.Action[name] then
		x.Action[name] = {}
	end
	x.Action[name].cast_time = castTime / 1000
	x.Action[name].execute_time = math.max(s.GlobalCooldown(), castTime / 1000)

	x.Action[name].travel_time = s.LastSpellTravelTime(spellId, "target") or 0.5
	local traveling = s.SpellDelay(spellId, "target", true)
	if traveling then
		x.Action[name].in_flight_nogcd = true
	else
		x.Action[name].in_flight_nogcd = false
		x.Action[name].in_flight = false
		return
	end
	if traveling + math.max(s.GlobalCooldown(), s.GetCasting(nil, "player")) <= x.Action[name].travel_time then
		x.Action[name].in_flight = true
	else
		x.Action[name].in_flight = false
	end
end

s.UpdateTravelTime = s.UpdateInFlight
