local AddonName, a = ...
if a.BuildFail(50000) then return end
local s = SpellFlashAddon
local x = s.UpdatedVariables

local LAD = LibStub("LibArtifactData-1.0")

x.Artifact = {}
local updateArtifactTraits = function(message, artifactID)
	local changed = false
	local _, data = LAD:GetArtifactTraits(artifactID)
	for k, v in pairs(data) do
		local name = s.NormalizeName(v.name)
		if not x.Artifact[name] then
			x.Artifact[name] = {}
			changed = true
		end
		if x.Artifact[name].rank ~= v.currentRank then
			x.Artifact[name].rank = v.currentRank
			x.Artifact[name].enabled = v.currentRank > 0
			changed = true
		end
	end
	if changed then
		a.print("Successfully updated artifact data.")
	end
end
LAD.RegisterCallback(a, "ARTIFACT_EQUIPPED_CHANGED", updateArtifactTraits)
LAD.RegisterCallback(a, "ARTIFACT_TRAITS_CHANGED", updateArtifactTraits)
