local AddonName, a = ...
if a.BuildFail(50000) then return end
local s = SpellFlashAddon

-- Helper Functions

s.NormalizeName = function(name)
	if name:sub(1, 11) == "Incarnation" then
		return "incarnation"
	end
	return name:lower():gsub("s's", "s"):gsub(" ", "_"):gsub("[^a-z_]", ""):gsub("_+", "_")
end

s.FullRechargeTime = function(spellId, withDelay)
	local currentCharges, maxCharges, cooldownStart, cooldownDuration = GetSpellCharges(spellId)
	if currentCharges < maxCharges then
		if withDelay then
			return math.max(cooldownDuration - (GetTime() - cooldownStart) + cooldownDuration * (maxCharges - currentCharges - 1) - math.max(s.GlobalCooldown(), s.GetCasting(nil, "player")), 0)
		else
			return cooldownDuration - (GetTime() - cooldownStart) + cooldownDuration * (maxCharges - currentCharges - 1)
		end
	end
	return 0
end

s.PowerRegeneration = function()
	local regenRate
	_, regenRate = GetPowerRegen()
	regenRate = format("%.2f", regenRate)
	return tonumber(regenRate)
end
